 class ConcreteMediator extends Mediator{

	 private OnePilot aOnePilot;
	 private NextPilot aNextPilot;

	 public void pilotChanged( Pilot theChangedPilot ){
		 
		 if ((( OnePilot)theChangedPilot).getSelection().equals( aOnePilot.getSelection() ) ){
			 aNextPilot.setText( aOnePilot.getSelection() );
		 }
	 }
	 
	 public void createConcreteMediator(){
		 aOnePilot = new OnePilot(this, "OnePilot");
		 aNextPilot = new NextPilot(this, "NextPilot");
	 }
	 
	 public OnePilot getOnePilot(){
		 return(aOnePilot);
	 }
	 
	 public NextPilot getNextPilot(){
		 return(aNextPilot);
	 }
 }