import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.awt.FontMetrics;


class Mediator {
    ButtonDice btnDc;
    ButtonPrevious btnPrvs;
    ButtonClear btnClr;
    Display display;
    java.util.List list, undo;
    boolean restart = true;
    int counter = 0, ct = 0;
    //....
    Mediator() {
       list = new ArrayList();
       undo = new ArrayList();
    }
    void registerDice(ButtonDice bd) {
        btnDc = bd;
    }
    void registerClear(ButtonClear bc) {
        btnClr = bc;
    }
    void registerPrevious(ButtonPrevious bp) {
        btnPrvs = bp;
    }
    void registerDisplay(Display disp) {
        display = disp;
    }
    void throwit() {
       display.setForeground(Color.black);
       int num = (int)(Math.random()*6 +1);
       int i = counter++;
       list.add(i, new Integer(num));
       undo.add(i, new Memento(num));
       display.setText(""+num);
    }
    
    void previous() {
       display.setForeground(Color.red);
       btnDc.setEnabled(false);
       if (undo.size() > 0) {       
           ct = undo.size()-1;
           Memento num = (Memento)undo.get(ct);
           display.setText(""+num.getNumber());
           undo.remove(ct);
       }
       if (undo.size() == 0)
           display.setText("0");
    }
    void clear() {
        list = new ArrayList();
        undo = new ArrayList();
        counter = 0;
        display.setText("0");
        btnDc.setEnabled(true);
    }   
}