import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.awt.FontMetrics;


class MementoDemoDp extends JFrame implements ActionListener {
    Mediator mediator = new Mediator();
    MementoDemoDp() {
       JPanel panel = new JPanel();
       panel.add(new ButtonDice(this,mediator));
       panel.add(new ButtonPrevious(this,mediator));
       panel.add(new ButtonClear(this,mediator));
       JPanel dice = new JPanel();
       Display disp = new Display(mediator);
       dice.add(disp);
       getContentPane().add(dice, "Center");
       getContentPane().add(panel, "South");
       setTitle("Memento pattern example");
       setDefaultCloseOperation(EXIT_ON_CLOSE);
       setSize(400,200);
       setVisible(true);
    }
    public void actionPerformed(ActionEvent ae) {
        Command cmd = (Command)ae.getSource();
        cmd.execute();
    }
    public static void main(String[] args) {
        new MementoDemoDp();
    }
}