import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.awt.FontMetrics;

class ButtonClear extends JButton implements Command {
    Mediator mediator;
    ButtonClear(ActionListener al, Mediator med) {
        super("Clear");
        addActionListener(al);
        mediator = med;
        mediator.registerClear(this);
    }
    public void execute() {
       mediator.clear();
    }
}